%
% ProTcl 1.1
%
%	Definitions common to all Prologs
%
% Author: Micha Meier
%
%
% sccsid("@(#)tk_common.pl	1.7          94/05/17").
% sccscr("@(#)  Copyright 1993 ECRC GmbH ").
%

tk_demo :-
    tk_init('$tk_library/demos/widget', []),
    tcl_eval('source $tk_library/demos/widget'),
    % now add our local demos
    tcl_eval('source $protcl_library/local/init'),
    tcl_eval(update),
    tk_main_loop.

tk_test :-
    tk([]),
    tk_source(S),
    concat_atoms('cd ', S, CDS),
    concat_atoms(CDS, '/tests', CDT),
    tcl_eval(CDT),
    tcl_eval('source all'),
    tcl_eval('exit').

tk_init(File, Opts) :-
    tk_clear_options,
    tk_options(Opts),
    tk_init(File),
    protcl_source(ProTcl),
    concat_atoms('global protcl_library; set protcl_library ', ProTcl, SP),
    tcl_eval(SP).

tk_options([]).
tk_options([Opt|List]) :-
    Opt =.. [Name|Args],
    (Args = [Val|_] ->
	true
    ;
	Val = ''
    ),
    tk_option(Name, Val),
    tk_options(List).

tk_file(File, Options) :-
    tk_init(File, Options),
    concat_atoms('source ', File, InitFile),
    tcl_eval(InitFile),
    tcl_eval(update),
    tk_main_loop.

tk_main_loop :-
    tk_do_one_event(0),
    tk_num_main_windows(X), X > 0 ->
	tk_main_loop
    ;
	true.

tcl_eval(S) :-
    tcl_eval(S, _).
